<?php 
class emiPrivateMessages_Controller{
	protected static $instance;
	public static function singleton() {
		if (! isset ( self::$instance )) {
			$c = __CLASS__;
			self::$instance = new $c ( );
		}

		return self::$instance;
	}
	private static function _get_include_contents($t_filename) {
		if (is_file($t_filename)) {
			ob_start();
			include $t_filename;
			return ob_get_clean();
		}
		return false;
	}
	public static function getLink($_link, $t_fromDialog=false) {
		global $wp;
		 
		$fnControl = new stdClass;
		$fnControl->result = $_link;
		 
		if(isset($wp->query_vars)){
			if($wp->did_permalink){
				if($t_fromDialog){
					$fnControl->result='../?'.$_link;
				}
				else{
					$fnControl->result='?'.$_link;
				}
			}
			else{
				$fnControl->result= '?page_id='.$_REQUEST['page_id'].'&'.$_link;
			}
		}
		else{
			$fnControl->result='?'.$_link;
		}
		 
		return $fnControl->result;
	}
	public static function adminOptions(){
		$fnControl = new stdClass;
		$fnControl->options = get_option( 'emiPrivateMessages' );
		return $fnControl;
	}
	public static function inbox(){
		global $current_user, $wp;
		$fnControl = new stdClass;
		$fnControl->newMessageInterval = EmiPrivateMessages::$options['newInboxMessageInterval'];

		$fnControl->userId = $current_user->ID;
		$fnControl->permalinked=false;
		if(isset($wp->query_vars) && $wp->did_permalink){
			$fnControl->permalinked=true;
		}
		
		if(isset($wp->query_vars)){
			if($wp->did_permalink){
				$fnControl->dialogUrl='%d';
			}
			else{
				$fnControl->dialogUrl= '?page_id='.$_REQUEST['page_id'].'&page=emiPrivateMessages_dialog&userId=%d';
			}
		}
		else{
			$fnControl->dialogUrl='?page=emiPrivateMessages_dialog&userId=%d';
		}

		$fnControl->messages = EmiPrivateMessages::$DB->getDialogs($current_user->ID,0,EmiPrivateMessages::$options['dialogsPerPage']);

		$fnControl->lastMessageId = 0;
		if(isset($fnControl->messages[0])){
			$fnControl->lastMessageId = $fnControl->messages[0]->id;
		}
		 
		$fnControl->totalDialog = EmiPrivateMessages::$DB->getTotalDialogs($current_user->ID);

		$fnControl->pagination = 'none';
		$fnControl->totalPage = ceil($fnControl->totalDialog/EmiPrivateMessages::$options['dialogsPerPage']);
		if($fnControl->totalPage>1){
			$fnControl->pagination ='';
		}
		return $fnControl;
	}
	public static function dialog() {
		global $current_user, $wp;
		$fnControl = new stdClass;
		$fnControl->newMessageInterval = EmiPrivateMessages::$options['newDialogMessageInterval'];
		$fnControl->userId = $current_user->ID;
		$fnControl->userDisplayName = $current_user->display_name;
		if ( isset( $_GET['userId'] ) ) {
			$fnControl->partnerId = intVal($_GET['userId'],10);
		}
		else{
			$fnControl->partnerId = intval(preg_replace('/[^0-9]*/i', '', $wp->query_vars['page']));
		}

		$fnControl->partnerInfo = get_userdata($fnControl->partnerId);
		$fnControl->partnerAvatar=get_avatar($fnControl->partnerId,48);
		 
		$fnControl->userAvatar=get_avatar($current_user->ID,48);
		 
		if ( $current_user->ID<$fnControl->partnerId ) {
			$fnControl->_key = $current_user->ID.'-'. $fnControl->partnerId;
		}
		else{
			$fnControl->_key = $fnControl->partnerId.'-'.$current_user->ID;
		}

		$fnControl->messages = EmiPrivateMessages::$DB->getDialogMessages($current_user->ID,$fnControl->_key);
		EmiPrivateMessages::$DB->setMessageStatus2Read($current_user->ID,$fnControl->_key);
		$fnControl->lastMessageId = 0;
		if(isset($fnControl->messages[0])){
			$fnControl->lastMessageId = $fnControl->messages[0]->id;
		}

		 
		$fnControl->messages = array_reverse($fnControl->messages);

		return $fnControl;
	}
	public static function send() {
		global $current_user, $wp;
		$fnControl = new stdClass;
		$fnControl->userAvatar=get_avatar($current_user->ID,48);
		 
		if(isset($wp->query_vars)){
			if($wp->did_permalink){
				$fnControl->dialogUrl='%d';
			}
			else{
				$fnControl->dialogUrl= '?page_id='.$_REQUEST['page_id'].'&page=emiPrivateMessages_dialog&userId=%d';
			}
		}
		else{
			$fnControl->dialogUrl='?page=emiPrivateMessages_dialog&userId=%d';
		}
		return $fnControl;
	}
	public static function ajax_sendMessage() {
		global $current_user;
		$fnControl = new stdClass;
		$fnControl->result =new stdClass();
		$fnControl->result->success = false;
		
		if(!isset($_POST['recipientId']) && !isset($_POST['recipient'])) {
			$fnControl->result->report = __('Unkown recipient','emiPrivateMessages');
			return $fnControl->result; 
		}
		if(isset($_POST['recipient'])){
			$fnControl->recipient = strip_tags( $_POST['recipient'] );
			if ( get_magic_quotes_gpc( ) ) {
				$fnControl->recipient = stripslashes( $fnControl->recipient );
			}
			$fnControl->recipient = esc_sql( $fnControl->recipient );
			$fnControl->recipient = EmiPrivateMessages::$DB->getUserWithId($fnControl->recipient);
			if(!isset($fnControl->recipient->ID) || $fnControl->recipient->ID<0){
				$fnControl->result->report = __('Unkown recipient','emiPrivateMessages');
				return $fnControl->result; 
			}
			$fnControl->recipientId = $fnControl->recipient->ID;
		}
		else{
			$fnControl->recipientId = intVal($_POST['recipientId'],10);
			if($fnControl->recipientId<=0){
				$fnControl->result->report = __('Unkown recipient','emiPrivateMessages');
				return $fnControl->result; 
			}
		}
		 
		if ( $current_user->ID<$fnControl->recipientId ) {
			$fnControl->_key = $current_user->ID.'-'.$fnControl->recipientId;
		}
		else{
			$fnControl->_key = $fnControl->recipientId.'-'.$current_user->ID;
		}
		 
		if(!isset($_POST['message']) || strlen($_POST['message'])<1 || $_POST['message']=='Write a message...') {
			$fnControl->result->report =  __('Empty message','emiPrivateMessages');
			return $fnControl->result; 
		}

		$fnControl->message = strip_tags( $_POST['message'] );
		if ( get_magic_quotes_gpc( ) ) {
			$fnControl->message = stripslashes( $fnControl->message );
		}
		$fnControl->message = esc_sql( $fnControl->message );

		if(EmiPrivateMessages::$DB->insertMessage($fnControl->_key, $fnControl->message, $current_user->ID, $fnControl->recipientId)){
			$fnControl->result->partnerId=$fnControl->recipientId;
			$fnControl->result->success=true;
			$fnControl->result->report = __('Message sent','emiPrivateMessages');
		}
		return $fnControl->result;
	}
	public static function ajax_deleteMessage(){
		global $current_user;
		$fnControl = new stdClass;
		$fnControl->result =new stdClass();
		$fnControl->result->success = false;
		
		if (!isset( $_REQUEST['messageId'] ) ) {
			$fnControl->result->report = __('Invalid argument','emiPrivateMessages');
			return $fnControl->result; 
		}
		$fnControl->messageId = intVal($_REQUEST['messageId'],10);
		if($fnControl->messageId<=0){
			$fnControl->result->report = __('Invalid argument','emiPrivateMessages');
			return $fnControl->result; 
		}
		
		$message = EmiPrivateMessages::$DB->getMessage($fnControl->messageId);
		if ($current_user->ID==$message->sender_id ) {
			if(EmiPrivateMessages::$DB->setMessageSenderStatus2Delete($fnControl->messageId, $current_user->ID)){
				$fnControl->result->success=true;
			}
		}
		else if ($current_user->ID==$message->recipient_id) {
			if(EmiPrivateMessages::$DB->setMessageRecipientStatus2Delete($fnControl->messageId, $current_user->ID)){
				$fnControl->result->success=true;
			}
		}

		return $fnControl->result;
	}
	public static function ajax_getUser(){
		global $current_user;
		$fnControl = new stdClass;
		$fnControl->result =new stdClass();
		$fnControl->result->success = false;
	
		if ( !isset( $_REQUEST['term'] ) ) {
			$fnControl->result->report = __('Invalid argument','emiPrivateMessages');
			return $fnControl->result; 
		}
		$fnControl->term = strip_tags( $_REQUEST['term'] );
		if ( get_magic_quotes_gpc( ) ) {
			$fnControl->term = stripslashes($fnControl->term);
		}
		$fnControl->term = esc_sql($fnControl->term);
		
		$fnControl->term = '%'.$fnControl->term .'%';
	
		$fnControl->result->data = EmiPrivateMessages::$DB->getRecentRecipientsWithQuery($current_user->ID,$fnControl->term);
	
		$tempArray = array(0);
		foreach ($fnControl->result->data  as $eUser){
			array_push($tempArray,$eUser->ID);
		}
		$count = count($fnControl->result->data);
		
		if($count<10){
			$tempData = EmiPrivateMessages::$DB->getRecipientsWithQuery($current_user->ID, $fnControl->term,$tempArray);
			$fnControl->result->data = array_merge($fnControl->result->data,$tempData);
		}
		foreach ($fnControl->result->data  as $eUser){
			$eUser->avatar=get_avatar($eUser->ID,32);
		}
		return $fnControl->result->data;
	}
	public static function ajax_getDialogPage(){
		global $current_user;
		$fnControl = new stdClass;
		$fnControl->result =new stdClass();
		$fnControl->result->success = false;
	
		if(!isset($_GET['partnerId']) || !isset($_GET['page'])) {
			$fnControl->result->report = __('Invalid argument','emiPrivateMessages');
			return $fnControl->result; 
		}
		
		$fnControl->partnerId = intVal($_GET['partnerId'],10);
		$fnControl->page = intVal($_GET['page'],10);
		$fnControl->start = ($fnControl->page-1)*10;
		$fnControl->limit = intVal(EmiPrivateMessages::$options['messagesPerPage']);
		if($fnControl->partnerId<=0 || $fnControl->page<0){
			$fnControl->result->report = __('Invalid argument','emiPrivateMessages');
			return $fnControl->result; 
		}
		
		$fnControl->partnerInfo = get_userdata($fnControl->partnerId);
		$fnControl->partnerAvatar=get_avatar($fnControl->partnerId,48);
		
		$fnControl->userAvatar=get_avatar($current_user->ID,48);
		
		if ( $current_user->ID<$fnControl->partnerId ) {
			$fnControl->_key = $current_user->ID.'-'.$fnControl->partnerId;
		}
		else{
			$fnControl->_key = $fnControl->partnerId.'-'.$current_user->ID;
		}
		

		$fnControl->result->totalMessages = EmiPrivateMessages::$DB->getTotalDialogMessages($fnControl->_key, $current_user->ID);
		
	
		$fnControl->messages = EmiPrivateMessages::$DB->getDialogMessages($current_user->ID,$fnControl->_key,$fnControl->start,$fnControl->limit);

		EmiPrivateMessages::$DB->setMessageStatus2Read($current_user->ID,$fnControl->_key);
		$fnControl->messages = array_reverse($fnControl->messages);

		ob_start();
		foreach ( $fnControl->messages as $eMsg ) {
			$tempControl = new stdClass;
			$tempControl->extraClass='';
			if($current_user->ID==$eMsg->sender_id){
				$tempControl->avatar = $fnControl->userAvatar;
				$tempControl->displayName = $current_user->display_name;
				if($eMsg->sender_status==1){
					$tempControl->extraClass=' selectorDialogMessageUnread';
				}
			}
			else{
				$tempControl->avatar = $fnControl->partnerAvatar;
				$tempControl->displayName = $fnControl->partnerInfo->display_name;
				if($eMsg->recipient_status==1){
					$tempControl->extraClass=' selectorDialogMessageUnread';
				}
			}
			include('templates/dialogMessage.php');		
		}
		$fnControl->result->messages = ob_get_clean();;

		$fnControl->result->success=true;
		return $fnControl->result;
	}
	public static function ajax_getNewDialogMessages(){
		global $current_user;
		$fnControl = new stdClass;
		$fnControl->result =new stdClass();
		$fnControl->result->success = false;
	
		if(!isset($_GET['partnerId'])) {
			$fnControl->result->report = __('Invalid argument','emiPrivateMessages');
			return $fnControl->result;
		}
	
		$fnControl->partnerId = intVal($_GET['partnerId'],10);
		if($fnControl->partnerId<=0){
			$fnControl->result->report = __('Invalid argument','emiPrivateMessages');
			return $fnControl->result; 
		}
		$fnControl->lastId = intVal($_GET['lastId'],10);
		if($fnControl->lastId<0){
			$fnControl->result->report = __('Invalid argument','emiPrivateMessages');
			return $fnControl->result; 
		}
		$fnControl->partnerInfo = get_userdata($fnControl->partnerId);
		$fnControl->partnerAvatar=get_avatar($fnControl->partnerId,48);

		$fnControl->userAvatar=get_avatar($current_user->ID,48);

		if ( $current_user->ID<$fnControl->partnerId ) {
			$fnControl->_key = $current_user->ID.'-'.$fnControl->partnerId;
		}
		else{
			$fnControl->_key = $fnControl->partnerId.'-'.$current_user->ID;
		}
	
	
		$fnControl->messages = EmiPrivateMessages::$DB->getDialogMessages($current_user->ID,$fnControl->_key,0,10,$fnControl->lastId);

		EmiPrivateMessages::$DB->setMessageStatus2Read($current_user->ID,$fnControl->_key);
		
		
		$fnControl->result->newMessages = count($fnControl->messages);
		if($fnControl->result->newMessages>0){
			$fnControl->result->lastId = $fnControl->messages[0]->id;
		}
		else{
			$fnControl->result->lastId = $fnControl->lastId;
		}
		$fnControl->messages = array_reverse($fnControl->messages);
		ob_start();
		foreach ( $fnControl->messages as $eMsg ) {
			$tempControl = new stdClass;
			$tempControl->extraClass='';
			if($current_user->ID==$eMsg->sender_id){
				$tempControl->avatar = $fnControl->userAvatar;
				$tempControl->displayName = $current_user->display_name;
				if($eMsg->sender_status==1){
					$tempControl->extraClass=' selectorDialogMessageUnread';
				}
			}
			else{
				$tempControl->avatar = $fnControl->partnerAvatar;
				$tempControl->displayName = $fnControl->partnerInfo->display_name;
				if($eMsg->recipient_status==1){
					$tempControl->extraClass=' selectorDialogMessageUnread';
				}
			}
			include('templates/dialogMessage.php');	


		}
		$fnControl->result->messages = ob_get_clean();;

		$fnControl->result->success=true;
		return $fnControl->result;
	}
	public static function ajax_getNewInboxMessages(){
		global $current_user;
		$fnControl = new stdClass;
		$fnControl->result =new stdClass();
		$fnControl->result->success = false;
	
		if(!isset($_GET['lastId'])) {
			$fnControl->result->report = __('Invalid argument','emiPrivateMessages');;
			return $fnControl->result;
		}
	
		$fnControl->lastId = intVal($_GET['lastId'],10);
		if($fnControl->lastId<0){
			$fnControl->result->report = __('Invalid argument','emiPrivateMessages');;
			return $fnControl->result;
		}
	
		
	
		$fnControl->messages = EmiPrivateMessages::$DB->getDialogs($current_user->ID,0,10,$fnControl->lastId);
				
		$fnControl->result->newMessages = count($fnControl->messages);
		$fnControl->result->lastId = 0;
		if($fnControl->result->newMessages>0){
			$fnControl->result->lastId = $fnControl->messages[0]->id;
		}
		$fnControl->result->messages = array();
					
		$fnControl->permalinked=false;
		if(isset($wp->query_vars) && $wp->did_permalink){
			$fnControl->permalinked=true;
		}
		
		foreach ( $fnControl->messages as $eMsg ) {
			$tempMessage = new stdClass();
					$tempMessage->_key = $eMsg->_key;
						
					$tempControl = new stdClass;
					$tempControl->message = stripcslashes($eMsg->message);
					$tempControl->extraClass='';
						
					if( strlen($tempControl->message)>97){
						$tempControl->message=substr($tempControl->message, 0,97).'...';
					}
					if($current_user->ID==$eMsg->sender_id){
						$tempControl->userID = $eMsg->recipient_id;
						$tempControl->userDisplayName = $eMsg->recipient_display_name;
						$tempControl->direction = 'left';
						if($eMsg->sender_status==1)$tempControl->extraClass.='selectorInboxMessageUnread';
					}
					else{
						$tempControl->userID = $eMsg->sender_id;
						$tempControl->userDisplayName = $eMsg->sender_display_name;
						$tempControl->direction = 'right';
						if($eMsg->recipient_status==1)$tempControl->extraClass.='selectorInboxMessageUnread';
					}
					
					$tempControl->dialogUrl=str_replace('%d',$tempControl->userID,$_GET['dialogUrl']);
					
					ob_start();
					include('templates/inboxMessage.php');
					$tempMessage->message = ob_get_clean();;
					array_push($fnControl->result->messages, $tempMessage);
		}
	
		$fnControl->result->success=true;
		return $fnControl->result;
	}
	public static function ajax_getInboxPage(){
		global $current_user;
		$fnControl = new stdClass;
		$fnControl->result =new stdClass();
		$fnControl->result->success = false;
		if(!isset($_GET['page'])) {
			$fnControl->result->report = __('Invalid argument','emiPrivateMessages');;
			return $fnControl->result;
		}
		
		
		$fnControl->page = intVal($_GET['page'],10);
		$fnControl->start = ($fnControl->page-1)*5;
		$fnControl->limit = intVal(EmiPrivateMessages::$options['dialogsPerPage']);
		if($fnControl->page<0){
			$fnControl->result->report = __('Invalid argument','emiPrivateMessages');;
			return $fnControl->result;
		}
		
		
		$fnControl->messages = EmiPrivateMessages::$DB->getDialogs($current_user->ID,$fnControl->start ,$fnControl->limit);
			
			
		$fnControl->totalDialogs = EmiPrivateMessages::$DB->getTotalDialogs($current_user->ID);
			
		$fnControl->result->html = new stdClass();
		$fnControl->result->html->pagerContent = '<div>';
		ob_start();
		foreach ( $fnControl->messages as $eMsg ) {
			$tempControl = new stdClass;
			$tempControl->message = stripcslashes($eMsg->message);
		
			$tempControl->extraClass='';
		
			if( strlen($tempControl->message)>97){
				$tempControl->message=substr($tempControl->message, 0,97).'...';
			}
			if($current_user->ID==$eMsg->sender_id){
				$tempControl->userID = $eMsg->recipient_id;
				$tempControl->userDisplayName = $eMsg->recipient_display_name;
				$tempControl->direction = 'left';
				if($eMsg->sender_status==1)$tempControl->extraClass.='selectorInboxMessageUnread';
			}
			else{
				$tempControl->userID = $eMsg->sender_id;
				$tempControl->userDisplayName = $eMsg->sender_display_name;
				$tempControl->direction = 'right';
				if($eMsg->recipient_status==1)$tempControl->extraClass.='selectorInboxMessageUnread';
			}
		
			$tempControl->dialogUrl=str_replace('%d',$tempControl->userID,$_GET['dialogUrl']);
			
			include('templates/inboxMessage.php');
				
		}
		$fnControl->result->html->pagerContent .= ob_get_clean();
		$fnControl->result->html->pagerContent .= '</div>';
		
		$fnControl->result->success=true;
	
		return $fnControl->result;
	}
}

?>