<?php
class emiPrivateMessages_DB{
     protected static $instance;
     public static function singleton() {
          if (! isset ( self::$instance )) {
               $c = __CLASS__;
               self::$instance = new $c ( );
          }
          return self::$instance;
     }
     public static function getUserWithId($t_query){
     	global $wpdb;
     	return $wpdb->get_row($wpdb->prepare( 'SELECT U.ID FROM '.$wpdb->prefix.'users U WHERE U.display_name = %s',$t_query));
     }
     public static function getRecentRecipientsWithQuery($t_userId, $t_query){
     	global $wpdb;
     	return $result->data = $wpdb->get_results( $wpdb->prepare( '
     		SELECT
     		EPM.recipient_id AS ID,
     		U.display_name AS label
     		FROM
     		wp_private_messages EPM
     		JOIN '.$wpdb->prefix.'users U ON (U.ID=EPM.recipient_id)
     		WHERE
     		EPM.sender_id=%d
     		AND U.display_name LIKE %s
     		GROUP BY EPM.recipient_id,U.display_name
     		ORDER BY COUNT(EPM.recipient_id) DESC, U.display_name ASC
     		LIMIT 0,10
     	',$t_userId,$t_query));
     }
     public static function getRecipientsWithQuery($t_userId, $t_query, $t_ignoreUsers = array(0)){
     	global $wpdb;
     	return $wpdb->get_results( $wpdb->prepare( '
     		SELECT
     		U.ID,
     		U.display_name AS label
     		FROM
     		'.$wpdb->prefix.'users U
     		WHERE
     		U.id!=%d
     		AND U.display_name LIKE %s
     		AND U.id NOT IN('.implode(',',$t_ignoreUsers).')
     		ORDER BY U.display_name ASC
     		LIMIT 0,'.(10-count($t_ignoreUsers))
     		,$t_userId,$t_query));
     }
     public static function insertMessage($t_key, $t_message, $t_senderId, $t_recipientId){
     	global $wpdb;
		return $wpdb->insert(
			wp_private_messages,
			array(
				'_key' => $t_key,
				'message'=> $t_message,
				'sender_id'=>$t_senderId,
				'recipient_id'=>$t_recipientId
			)
		);
     }
     public static function getMessage($t_id){
     	global $wpdb;
     	return $wpdb->get_row($wpdb->prepare('
     			SELECT
     				EPM.sender_id,
     				EPM.recipient_id
     			FROM wp_private_messages EPM
     			WHERE id = %d
     	',$t_id));
     } 
     public static function getTotalDialogMessages($t_key, $t_userId){
     	global $wpdb;
     	return $wpdb->get_var($wpdb->prepare( '
				SELECT
				COUNT(EPM.id)
				FROM
				wp_private_messages EPM
				WHERE
				EPM._key=%s
				AND((EPM.sender_id=%d AND EPM.sender_status>0) OR (EPM.recipient_id=%d AND EPM.recipient_status>0))
			',$t_key, $t_userId, $t_userId));
     }
     public static function getTotalUnread($t_userId){
     	global $wpdb;
     	return $wpdb->get_var( $wpdb->prepare('
     			SELECT
     			COUNT(EPM.id)
     			FROM
     			wp_private_messages EPM
     			WHERE
     			EPM.recipient_status=1
     			AND EPM.recipient_id=%d
     	', $t_userId));
     }
     public static function getDialogs($t_userId, $t_start=0, $t_limit=10,$t_fromId=0){
     	global $wpdb;
     	return $wpdb->get_results( $wpdb->prepare( '
     			SELECT
     			EPM._key,
     			EPM.id,
     			SUBSTR(EPM.message,1,100) AS message,
     			EPM.sender_id,
     			EPM.recipient_id,
     			EPM.create_time,
     			EPM.sender_status,
     			EPM.recipient_status,
     			SU.display_name AS sender_display_name,
     			RU.display_name AS recipient_display_name
     			FROM
     			wp_private_messages EPM
     			JOIN ( SELECT MAX(JEPM.id) AS id FROM wp_private_messages JEPM WHERE JEPM.id>%d AND((JEPM.sender_id=%d AND JEPM.sender_status>0) OR (JEPM.recipient_id=%d AND JEPM.recipient_status>0)) GROUP BY JEPM._key) R1 ON EPM.id=R1.id
     			JOIN '.$wpdb->prefix.'users SU ON ( SU.id = EPM.sender_id )
     			JOIN '.$wpdb->prefix.'users RU ON ( RU.id = EPM.recipient_id )
     			
     			ORDER BY EPM.id DESC
     			LIMIT '.$t_start.','.$t_limit.'
     	',$t_fromId, $t_userId, $t_userId));
     }
     public static function getTotalDialogs($t_userId){
     	global $wpdb;
     	return $wpdb->get_var( $wpdb->prepare( '
     			SELECT
     			COUNT(DISTINCT EPM._key) 
     			FROM
     			wp_private_messages EPM
     			WHERE
     			EPM.sender_id=%d
     			OR EPM.recipient_id=%d
     	',$t_userId,$t_userId));
     }
     public static function getDialogMessages($t_userId, $t_key, $t_start=0,$t_limit=10,$t_fromId=0){
		global $wpdb;
     	return $wpdb->get_results( $wpdb->prepare( '
     			SELECT
     			EPM.id,
     			EPM.message,
     			EPM.sender_id,
     			EPM.recipient_id,
     			EPM.sender_status,
     			EPM.recipient_status,
     			EPM.create_time     			
     			FROM
     			wp_private_messages EPM
     			WHERE
     			EPM._key=%s
     			AND((EPM.sender_id=%d AND EPM.sender_status>0) OR (EPM.recipient_id=%d AND EPM.recipient_status>0))
     			AND EPM.id>%d
     			ORDER BY EPM.id DESC
     			LIMIT '.$t_start.','.$t_limit.'
     	', $t_key, $t_userId, $t_userId, $t_fromId));
     }
     public static function getInboxMessages($t_userId, $t_key, $t_start=0,$t_limit=10,$t_fromId=0){
     	global $wpdb;
     	return $wpdb->get_results( $wpdb->prepare( '
     			SELECT
     			EPM.id,
     			EPM.message,
     			EPM.sender_id,
     			EPM.recipient_id,
     			EPM.sender_status,
     			EPM.recipient_status,
     			EPM.create_time
     			FROM
     			wp_private_messages EPM
     			WHERE
     			EPM._key=%s
     			AND((EPM.sender_id=%d AND EPM.sender_status>0) OR (EPM.recipient_id=%d AND EPM.recipient_status>0))
     			AND EPM.id>%d
     			ORDER BY EPM.id DESC
     			LIMIT '.$t_start.','.$t_limit.'
     			', $t_key, $t_userId, $t_userId, $t_fromId));
     }
     public static function setMessageStatus2Read($t_userId, $t_key){
     	global $wpdb;
      	$wpdb->update(
     			wp_private_messages,
     			array(
     					'sender_status' => 2
     			),
     			array(
     					'_key'=>$t_key,
     					'sender_status'=>1,
     					'sender_id'=>$t_userId
     			)
     	);
     	$wpdb->update(
     			wp_private_messages,
     			array(
     					'recipient_status' => 2
     			),
     			array(
     					'_key'=>$t_key,
     					'recipient_status'=>1,
     					'recipient_id'=>$t_userId
     			)
     	);
     	return true;
     }
     public static function setMessageSenderStatus2Delete($t_messageId, $t_senderId){
     	global $wpdb;
		return $wpdb->update(
				wp_private_messages,
				array(
					'sender_status' => 0
				),
				array(
					'id'=>$t_messageId,
					'sender_id'=>$t_senderId
				)
		);
     }
     public static function setMessageRecipientStatus2Delete($t_messageId, $t_recipientId){
     	global $wpdb;
     	return $wpdb->update(
     			wp_private_messages,
     			array(
     					'recipient_status' => 0
     			),
     			array(
     					'id'=>$t_messageId,
     					'recipient_id'=>$t_recipientId
     			)
     	);
     }
}

?>