Emi.ns('Emi.lib.ui.pager');
Emi.lib.ui.pager = function(t_config){
	var t_config = jQuery.extend({
		pad: false,
		contentPad: false,
		url: false,
		params: {},
		currentPage: 1,
		totalPage:1,
		animation:true,
		renderer: function(){},
		callback: function(){}
	},t_config);
	var pager = {
		processing: false,
		pad: t_config.pad,
		contentPad: t_config.contentPad,
		url: t_config.url,
		params: t_config.params,
		currentPage: t_config.currentPage,
		totalPage: t_config.totalPage,
		renderer: t_config.renderer,
		pageSize: t_config.pageSize,
		animation: t_config.animation,
		callback: t_config.callback,
		overflowPad:t_config.contentPad.closest('.selectorOverflow'),
		previousQuery:'',
		query:'',
		elements: {
			firstPage:false,
			previousPage:false,
			currentPage:false,
			totalPage:false,
			nextPage:false,
			lastPage:false,
			indicator:false
		},
		go: function(t_page){
			if(pager.processing){
				return;
			}
			if((t_page==pager.currentPage && pager.query==pager.previousQuery) || t_page<1 || t_page>pager.totalPage){
				return
			}
			pager.processing = true;
			pager.previousQuery = pager.query;
			if(pager.elements.indicator){
				pager.elements.indicator.show();
			}

				jQuery.ajax({
					url: pager.url,
					type:'GET',
					dataType: 'JSON',
					data : jQuery.extend(pager.params,{page:t_page,query:pager.query}),
					success:function(response){
			    	if(pager.animation){
			    		var fixHeight = pager.overflowPad.height()-pager.contentPad.height();
			    		pager.overflowPad.css('height',(pager.overflowPad.height())+"px");
			    		
						
						var intOldHeight;
						var newMargin;
				    	if(t_page>pager.currentPage){
				    		pager.contentPad.append(response.html.pagerContent);
							$new = pager.contentPad.find('>:last');
							$old = pager.contentPad.find('>:first');
							intNewHeight = $new.height();
							intOldHeight = $old.height();
							newMargin='-'+intOldHeight+'px';
				    	}
				    	else{
				    		pager.contentPad.prepend(response.html.pagerContent);
							$new = pager.contentPad.find('>:first');
							intNewHeight = $new.height();
							pager.contentPad.css('margin-top','-'+(intNewHeight)+'px');
							$old = pager.contentPad.find('>:last');
							intOldHeight = $old.height();
							newMargin=0;
				    	}
				    	
						pager.contentPad.animate({
						    "margin-top": newMargin
						},{
							duration: 900,
							queue:false,
							complete:function(){
								$old.remove();
								pager.contentPad.css('margin-top','0px');
							}
						});
						
						pager.overflowPad.animate({
						    "height": (intNewHeight+fixHeight)+'px'
						},{
							duration: 910,
							complete:function(){
								pager.processing = false;
								if(pager.elements.indicator){
									pager.elements.indicator.hide();
								}
							}
						});
			    	}
			    	else{
			    		pager.contentPad.html(response.html.pagerContent);
			    	}
			    	pager.currentPage = t_page;
			    	pager.elements.currentPage.val(pager.currentPage);
			    	pager.callback(response);
			    	if(!pager.animation){
			    		pager.processing = false;
						if(pager.elements.indicator){
							pager.elements.indicator.hide();
						}
			    	}
			    	
				}
			});
		}
	};
		
	if(pager.pad){		
		pager.elements.firstPage = pager.pad.find('.selectorFirstPage');
		pager.elements.previousPage = pager.pad.find('.selectorPreviousPage');
		pager.elements.currentPage = pager.pad.find('.selectorCurrentPage');
		pager.elements.totalPage = pager.pad.find('.selectorTotalPage');
		pager.elements.nextPage = pager.pad.find('.selectorNextPage');
		pager.elements.lastPage = pager.pad.find('.selectorLastPage');
		pager.elements.indicator = pager.pad.find('.selectorIndicator');
		

		
		pager.currentPage = parseInt(pager.elements.currentPage.val(),10);
		pager.totalPage = parseInt(pager.elements.totalPage.val(),10);

		pager.elements.firstPage.attr('href','javascript:void(0);').click(function(){
			pager.go(1);
		});
		pager.elements.previousPage.attr('href','javascript:void(0);').click(function(){
			pager.go(pager.currentPage-1);
		});

		pager.elements.nextPage.attr('href','javascript:void(0);').click(function(){
			pager.go(pager.currentPage+1);
		});
		pager.elements.lastPage.attr('href','javascript:void(0);').click(function(){
			pager.go(pager.totalPage);
		});
		pager.elements.currentPage.width(8+pager.elements.currentPage.val().length*6).keyup(function(e){
			var intTarget = parseInt(pager.elements.currentPage.val(),10); 
			if(e.keyCode == 13) {
				if(intTarget<1){
					pager.elements.currentPage.val(1);
					pager.go(1);	
				}
				else if(intTarget>pager.totalPage){
					pager.elements.currentPage.val(pager.totalPage);
					pager.go(pager.totalPage);				
				}
				else{
					pager.go(intTarget);
				}
			}
			pager.elements.currentPage.width(8+pager.elements.currentPage.val().length*6);
			
		}).keydown(function(e){
	        var key = e.charCode || e.keyCode || 0;
	        return (
	            key == 8 || 
	            key == 9 ||
	            key == 46 ||
	            (key >= 37 && key <= 40) ||
	            (key >= 48 && key <= 57) ||
	            (key >= 96 && key <= 105)
	        );
		});
		
	}
	return pager;
}